#ifndef __CS_ALL_H
#define __CS_ALL_H

// System Headers
#include<cs/config.h> // system macros

// Core Headers
#include<cs/core/types.h>         // common data types
#include<cs/core/binary_traits.h> // binary traits
#include<cs/core/functions.h>     // common functions
#include<cs/core/io.h>            // input-output

// Math Includes
#include<cs/math/constants.h>  // constants
#include<cs/math/functions.h>  // general functions
#include<cs/math/error.h>      // error functions
#include<cs/math/matrix2x2.h>   // matrices
#include<cs/math/matrix3x3.h>   // matrices
#include<cs/math/matrix4x4.h>   // matrices
#include<cs/math/quaternion.h> // quaternions
#include<cs/math/uncertain.h>  // uncertain numbers
#include<cs/math/ray.h>        // rays
#include<cs/math/rotation.h>   // rotation

// Computer Graphics
#include<cs/cg/aabb.h>        // bounding boxes
#include<cs/cg/bvh.h>         // bounding box hierarchies
#include<cs/cg/texture.h>     // textures

#endif
